moXmlSettings = {};
source(MultiOverlayV3.modDir.."defaultSettings/moSetGetClientSettings.lua");
source(MultiOverlayV3.modDir.."defaultSettings/moSetGetAppSettings.lua");

function moXmlSettings:load(self, serverXml, languageXml, objectXml, clientXml, appXml)
	local file;
	local saveFile;
	local isSaveGameIndex = false;
	local appServer = false;
	function checkFile(xmlType, file, tableType)
		if not fileExists(file) then 
			moXmlSettings:generateXml(self, xmlType, file, tableType, false, appServer);
		else				
			moXmlSettings:loadXml(self, xmlType, file, tableType, appServer, isSaveGameIndex);			
		end;
	end;	
	if MultiOverlayV3.loadDetiServer then --or MultiOverlayV3.loadHostServer then
		--if serverXml then
		--	file = MultiOverlayV3.settingsDir.. "serverSettings.xml";
		--	if MultiOverlayV3.loadDetiServer then file = MultiOverlayV3.detiServerDir.. "serverSettings.xml";end;
		--	checkFile("serverSettings", file);
		--elseif appXml and not MultiOverlayV3.loadHostServer then --disabled apps server support (later new)
		--	file = MultiOverlayV3.settingsDir.. "appSettings.xml";
		--	if MultiOverlayV3.loadDetiServer then file = MultiOverlayV3.detiServerDir.. "appSettings.xml";end;
		--	appServer = true;
		--	checkFile("appSettings", file);
		--end;
	end;
	if not MultiOverlayV3.loadDetiServer or MultiOverlayV3.loadHostServer then		
		if languageXml then
			file = MultiOverlayV3.settingsDir.. "language.xml";		
			--saveFile = MultiOverlayV3.saveGameDir.. "language.xml";
			--if fileExists(saveFile) then file = saveFile;isSaveGameIndex=true;end;
			checkFile("language", file, moLanguageDefault);
		elseif clientXml then
			file = MultiOverlayV3.settingsDir.. "clientSettings.xml";
			saveFile = MultiOverlayV3.saveGameDir.. "clientSettings.xml";
			if fileExists(saveFile) then file = saveFile;isSaveGameIndex=true;end;
			checkFile("clientSettings", file);
		elseif objectXml then
			file = MultiOverlayV3.settingsDir.. "objectSettings.xml";
			saveFile = MultiOverlayV3.saveGameDir.. "objectSettings.xml";
			if fileExists(saveFile) then file = saveFile;isSaveGameIndex=true;end;
			checkFile("objectSettings", file);
		elseif appXml then
			file = MultiOverlayV3.settingsDir.. "appSettings.xml";
			saveFile = MultiOverlayV3.saveGameDir.. "appSettings.xml";
			if fileExists(saveFile) then file = saveFile;isSaveGameIndex=true;end;
			checkFile("appSettings", file);
		end;
	end;	
end;

function moXmlSettings:generateXml(self, xmlType, file, tableType, replaceXml, appServer)
	if replaceXml then
		print(tostring(MultiOverlayV3.metadata.title).. " replace ".. tostring(xmlType).. " xml file")
	else
		print(tostring(MultiOverlayV3.metadata.title).. " generated ".. tostring(xmlType).. " xml file")
	end;
	local int = 0;
	if xmlType == "language" then
		local Xml = createXMLFile("MultiOverlayV3_XML", file, xmlType);				
		for name, v in pairs(tableType) do			
			if name ~= nil and tableType[name] ~= nil then
				local xmlNameTag = ("language.text(%d)"):format(int);				
				setXMLString(Xml, xmlNameTag.."#name", name);
				for nameLanguage, v1 in pairs(v) do					
					setXMLString(Xml, xmlNameTag.. "#" ..tostring(nameLanguage), tostring(v1));				
				end;				
				int = int+1;
			end;
		end;				
		if not replaceXml then moLanguage = tableType;end;
		saveXMLFile(Xml);
		return;
	end;
	if xmlType == "appSettings" then
		moSetGetAppSettings:saveConfig(self, appServer);		
	end;
	if xmlType == "clientSettings" then			
		moSetGetOverlays:defaultFirstPda();
		moSetGetOverlays:defaultFirstSlot();
		moSetGetClientSettings:saveConfig(self);		
		return;		
	end;
end;

function moXmlSettings:loadXml(self, xmlType, file, tableType, appServer, isSaveGameIndex)
	local saveGame = "";
	if xmlType == "clientSettings" and isSaveGameIndex then saveGame = " (savegame".. g_currentMission.missionInfo.savegameIndex.. ")";end;
	if xmlType == "objectSettings" and isSaveGameIndex then saveGame = " (savegame".. g_currentMission.missionInfo.savegameIndex.. ")";end;
	if xmlType == "appSettings" and isSaveGameIndex then saveGame = " (savegame".. g_currentMission.missionInfo.savegameIndex.. ")";end;
	print(tostring(MultiOverlayV3.metadata.title).. " load ".. tostring(xmlType).. " xml file".. tostring(saveGame))
	local int=0;
	Xml = loadXMLFile("MultiOverlayV3_XML", file, xmlType);
	local xmlReplace = false;	
	if xmlType == "language" then
		while true do			
			local xmlNameTag = ("language.text(%d)"):format(int);			
			if getXMLString(Xml, xmlNameTag.."#name") then
				local name = string.lower(getXMLString(Xml, xmlNameTag.."#name"));				
				moLanguage[name] = {};								
				for a=1, #MultiOverlayV3.languageAccepts do	
					local text = getXMLString(Xml, xmlNameTag.. "#" ..tostring(MultiOverlayV3.languageAccepts[a]));
					if text ~= nil and string.len(text) >= 1 then
						moLanguage[name][MultiOverlayV3.languageAccepts[a]] = tostring(text);
						if tableType[name] ~= nil and tableType[name][MultiOverlayV3.languageAccepts[a]] ~= nil then tableType[name][MultiOverlayV3.languageAccepts[a]] = nil;end;						
					else
						if tableType[name] ~= nil and tableType[name][MultiOverlayV3.languageAccepts[a]] ~= nil then 
							moLanguage[name][MultiOverlayV3.languageAccepts[a]] = tostring(tableType[name][MultiOverlayV3.languageAccepts[a]]);
							xmlReplace = true;
						end;
					end;
				end;				
				if tableType[name] ~= nil and #tableType[name] <= 0 then tableType[name]=nil;end;
			else
				break;
			end;
			int = int+1;			
		end;		
		for name, v in pairs(tableType) do
			if name ~= nil and tableType[name] ~= nil then 			
				moLanguage[name] = {};
				for a=1, #MultiOverlayV3.languageAccepts do										
					local text = tostring(MultiOverlayV3.languageAccepts[a]);
					if text ~= nil and tableType[name][text] ~= nil then
						moLanguage[name][MultiOverlayV3.languageAccepts[a]] = tableType[name][text];
					end;					
				end;					
				xmlReplace = true;
			end;
		end;		
		--table.insert(moDeleteOldLanguage, "eggsbarn");
		for a=1, #moDeleteOldLanguage do
			if moLanguage[moDeleteOldLanguage[a]] ~= nil then
				moLanguage[moDeleteOldLanguage[a]] = nil;
				xmlReplace = true;
			end;
		end;		
		if xmlReplace then 
			moXmlSettings:generateXml(self, xmlType, file, moLanguage, true, false);			
		end;
		return;		
	end;
	if xmlType == "appSettings" then
		moSetGetAppSettings:loadConfig(self, Xml, xmlType, appServer, file, isSaveGameIndex);		
	end;
	if xmlType == "clientSettings" then		
		moSetGetClientSettings:loadConfig(self, Xml, xmlType, file, isSaveGameIndex, appFile);
		return;		
	end;
end;
